//+------------------------------------------------------------------+
//|                                      Find_pair_RGR_equity_v5.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|   14-   28-              |
//|   ,      14- |
//|        LendhtChannelBars       |
//|          (   ).                |
//|                                                                  |
//|    1 !!!                                   |
//|                                                                  |
//|  v2 -   :   StartSymbol            |
//|         13         |
//|                                                                  |
//|  v3 -   ;                                      |
//|     -      ;   |
//|     - .      .|
//|                                                                  |
//|  v4 -      .                 |
//|                                                                  |
//|  v5 -      .                 |
//|  |
//|  |
//+------------------------------------------------------------------+
#property copyright "GrayMan77"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 YellowGreen


//----  
extern int  LendhtChannelBars=300;
extern double FixLots=0.1;
extern string StartSymbol="EURUSD";
extern bool buyStartSymbol=true;
extern int FindSymbolsMax=13;         //    ( 27- )

extern bool ReverseNZDGBP=true;

//----  
double ExtMapBuffer1[];

//---- 

//   ( -  !!!)
string Symbols[]={"EURUSD","GBPUSD","USDCHF","USDJPY","AUDUSD","USDCAD",
               "NZDUSD","EURGBP","EURCHF","EURJPY","EURAUD","EURCAD",
               "EURNZD","GBPCHF","GBPJPY","GBPAUD","GBPCAD","NZDGBP",
               "CHFJPY","AUDCHF","CADCHF","NZDCHF","AUDJPY","CADJPY",
               "NZDJPY","AUDCAD","AUDNZD","NZDCAD"};
bool NotCalculate;
int startTime,fihishTime;
bool Error;

int NumberStartSymbol;
int nFindSymbols; //   
int FindSymbols[28]; //   
int FindTypes[28]; //     (0-buy; 1-sell)
double iCloseSymbols[][28];  //   (1-  - ; 2- -  
double BaseLots[28]; //   

int F_Symb[28],F_Typ[28]; //        
double F_Lots[28];
int nSymb;

double Equity[]; //  

double a,b,bh,bl; //   
double a_min,b_min,bh_min,bl_min,Eq_max,Eq_min;
//double WeightRGRmin;
double Abs_a_min;

int SymbMin,TypMin;

double WeidhtRGR[27],EquityMax[27],EquityMin[27],aRGR[27]; //    
double Spread[27],Swap[27];

int NumberWindow;  //   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int i;

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   Error=false;
   
   if(ReverseNZDGBP) Symbols[17]="GBPNZD";
   
   //    
   NumberStartSymbol=300;
   for(i=0; i<28; i++)
     if(Symbols[i]==StartSymbol) NumberStartSymbol=i;
   if(NumberStartSymbol>27) Error=true;
   
   NotCalculate=true;
   
   //       
   ArrayResize(iCloseSymbols,LendhtChannelBars+1);
   ArrayResize(Equity,LendhtChannelBars);
   
   // 
   ReadClose();
   
   //      
   for(i=0; i<28; i++)
     {
     BaseLots[i]=MarketInfo(Symbols[i],MODE_LOTSIZE);
     //Print("BaseLots[",i,"]=",BaseLots[i]);
     }
  
//----
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
   DelObj();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
  
  int i,j,k,m;
  bool Flag;
  string str1,str2,str3;
  double T1,T2,Price1,Price2;
  int AB;
  double Weight;
  double E_max,E_min,Delta,SumSpread,SumSwap;
  
  //  
  if(Error || FindSymbolsMax>27)
    {
    Print("   !");
    Alert("   !");
    return(-1);
    }
  
//----
  //   1 
  if(NotCalculate)
    {
    startTime=GetTickCount();
    
    nFindSymbols=1;
    FindSymbols[0]=NumberStartSymbol;
    if(buyStartSymbol) FindTypes[0]=0; // buy
      else FindTypes[0]=1; // sell
    
    //   13-      
    for(m=0; m<FindSymbolsMax; m++)
      {
      //WeightRGRmin=1000000000.;
      Abs_a_min=1000000000.;
    
      //   
      for(i=0; i<28; i++)
        {
        Flag=true;
        //     
        for(j=1; j<=nFindSymbols; j++)
          {
          if(i==FindSymbols[j-1]) Flag=false; //    !
          }
        
        if(Flag)
          {
          //    
          for(k=0; k<2; k++)
            {
            //         
            for(j=0; j<nFindSymbols; j++)
              {
              F_Symb[j]=FindSymbols[j];
              F_Typ[j]=FindTypes[j];
              F_Lots[j]=FixLots;
              }
            F_Symb[nFindSymbols]=i;
            F_Typ[nFindSymbols]=k;
            F_Lots[nFindSymbols]=FixLots;
            nSymb=m+2;
            /*
            //Print("nFindSymbols=",nFindSymbols,"   nSymb=",nSymb);
            Print(F_Symb[0],";",F_Symb[1],";",F_Symb[2],";",F_Symb[3],";",F_Symb[4],";",
            F_Symb[5],";",F_Symb[6],";",F_Symb[7],";",F_Symb[8],";",F_Symb[9],";",
            F_Symb[10],";",F_Symb[11],";",F_Symb[12],";",F_Symb[13]);
            */
            //  
            EquityCalculate();
            //      
            E_max=Equity[0];
            E_min=Equity[0];
            for(j=1; j<LendhtChannelBars; j++)
              {
              if(E_max<Equity[j]) E_max=Equity[j];
              if(E_min>Equity[j]) E_min=Equity[j];
              }
            
            //    
            RGRCalculate();
            
            //Weight=bh-bl;
            //Print("m=",m,"   =",i,"   =",k,"   Equity[0]=",Equity[0],"   Weight=",Weight);
            
            //  
            //if(bh-bl<WeightRGRmin)  //    
            if(MathAbs(a)<Abs_a_min)  //    
              {
              //WeightRGRmin=bh-bl;
              Abs_a_min=MathAbs(a);
              SymbMin=i;
              TypMin=k;
              a_min=a;
              b_min=b;
              bh_min=bh;
              bl_min=bl;
              Eq_max=E_max;
              Eq_min=E_min;
              SumSpread=SpreadCalculate();
              SumSwap=SwapCalculate();
              }
            //Print("WeightRGRmin=",WeightRGRmin);
            }
          }
        }
      
      nFindSymbols=m+2;
      FindSymbols[m+1]=SymbMin;
      FindTypes[m+1]=TypMin;
      WeidhtRGR[m]=bh_min-bl_min;
      aRGR[m]=a_min;
      EquityMax[m]=Eq_max;
      EquityMin[m]=Eq_min;
      Spread[m]=SumSpread;
      Swap[m]=SumSwap;
      
      str2="----";
      str3="----";
      for(k=0; k<nFindSymbols; k++)
        {
        str2=str2+Symbols[FindSymbols[k]]+";";
        if(FindTypes[k]==0)
          str3=str3+"buy;";
        else
          str3=str3+"sell;";
        }
      Print(str2);
      Print(str3);
      /*
      Print("----",FindSymbols[0],";",FindSymbols[1],";",FindSymbols[2],";",FindSymbols[3],";",FindSymbols[4],";",
            FindSymbols[5],";",FindSymbols[6],";",FindSymbols[7],";",FindSymbols[8],";",FindSymbols[9],";",
            FindSymbols[10],";",FindSymbols[11],";",FindSymbols[12],";",FindSymbols[13]);
      */
      //Print("m=",m,"    WeightRGRmin=",WeightRGRmin);
      Print("m=",m,"    Abs_a_min=",Abs_a_min);
      }
    
    //   
    //         
    for(j=0; j<=FindSymbolsMax; j++)
      {
      F_Symb[j]=FindSymbols[j];
      F_Typ[j]=FindTypes[j];
      F_Lots[j]=FixLots;
      }
    nSymb=nFindSymbols;
    Print("------- nFindSymbols=",nFindSymbols);
    
    //  
    EquityCalculate();
    
    //    
    RGRCalculate();
    Print("a=",a,"    b=",b,"   bh=",bh,"    bl=",bl);
    
    //  
    for(i=1; i<=LendhtChannelBars; i++)
      ExtMapBuffer1[i]=Equity[i-1];
    
    //  
    //    
    NumberWindow=WindowFind(WindowExpertName());
    //   
     AB=LendhtChannelBars;
     T1=Time[AB+1];
     T2=Time[1];
     Price1=a*AB+b;
     Price2=a+b;
     ObjectCreate("MIDL1",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2);
		   ObjectSet("MIDL1",OBJPROP_COLOR,Lime); 
	   	ObjectSet("MIDL1",OBJPROP_WIDTH,1); 
	   	ObjectSet("MIDL1",OBJPROP_STYLE,STYLE_DOT);
	

     //    
     Price1=a*AB+bh;
     Price2=a+bh;
     ObjectCreate("TL11",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2); 
	   	ObjectSet("TL11",OBJPROP_COLOR,Lime); 
	   	ObjectSet("TL11",OBJPROP_WIDTH,2); 
   		ObjectSet("TL11",OBJPROP_STYLE,STYLE_SOLID); 

     //    
     Price1=a*AB+bl;
     Price2=a+bl;
	  ObjectCreate("TL21",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2); 
		   ObjectSet("TL21",OBJPROP_COLOR,Lime); 
	   	ObjectSet("TL21",OBJPROP_WIDTH,2); 
   		ObjectSet("TL21",OBJPROP_STYLE,STYLE_SOLID); 
    
    //  
    str1="\n      \n (C) GrayMan77 \n                .             .                         Max           Min                              ";
    if(FindTypes[0]==0)
        str1=str1+" \n1.  "+Symbols[FindSymbols[0]]+"    buy";
      else
        str1=str1+" \n1.  "+Symbols[FindSymbols[0]]+"    sell";
      str1=str1+"                 "+DoubleToStr(FixLots,2);
    
    for(i=1; i<=FindSymbolsMax; i++)
      {
      j=i+1;
      k=i-1;
      if(FindTypes[i]==0)
        str1=str1+" \n"+j+".  "+Symbols[FindSymbols[i]]+"      buy";
      else
        str1=str1+" \n"+j+".  "+Symbols[FindSymbols[i]]+"      sell";
      str1=str1+"             "+DoubleToStr(FixLots,2);
      str1=str1+"           "+DoubleToStr(WeidhtRGR[k],2);
      if(aRGR[k]<0) str1=str1+"           ";
        else str1=str1+"           ";
      Delta=EquityMax[k]-EquityMin[k];
      str1=str1+"        "+DoubleToStr(-1.*aRGR[k],4)+"        "+DoubleToStr(EquityMax[k],2)+"         "+DoubleToStr(EquityMin[k],2)+"          "+DoubleToStr(Delta,2)+"              "+DoubleToStr(Spread[k],2)+"             "+DoubleToStr(Swap[k],2);
      
      }
    Comment(str1);
    
    /*
    WeidhtRGR[m]=bh_min-bl_min;
      aRGR[m]=a_min;
      EquityMax[m]=Eq_max;
      EquityMin[m]=Eq_min;
    */
    
    NotCalculate=false;

    //Print("  :  ",mln," .  ",k);
    //   
    fihishTime=GetTickCount();
    Print("  ",(fihishTime-startTime)/100," .");
    }
   
//----
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    iCloseSymbols[][]  Close[]          |
//|   28-    LendhtChannelBars        |
//|    (LendhtChannelBars+1)  Open[]!     |
//+------------------------------------------------------------------+
void ReadClose()
  {
  int i,j;
  datetime TimeBar;
  
  //   
  for(i=0; i<28; i++)
    {
    //   
    for(j=0; j<LendhtChannelBars; j++) // 0-   !!!
      {
      TimeBar=Time[j+1];
      iCloseSymbols[j][i]=iClose(Symbols[i],Period(),iBarShift(Symbols[i],Period(),TimeBar,false));
      }
    TimeBar=Time[LendhtChannelBars+1];
    iCloseSymbols[LendhtChannelBars][i]=iOpen(Symbols[i],Period(),iBarShift(Symbols[i],Period(),TimeBar,false));
    }
  /*
  for(i=0; i<28; i++)
    {
    Print("!!!!! ---- i=",i,"   Symbol=",Symbols[i],"    iCloseSymbols=",iCloseSymbols[0][i]);
    }
  */
  return;
  }
//+------------------------------------------------------

//+----------------------------------------------------------------------------+
//|                                                                |
//|       F_Symb[],F_Typ[],F_Lots[]             |
//|                                                         nSymb;     |
//|      Equity[]  LendhtChannelBars;       |
//|      iCloseSymbols[][] (LendhtChannelBars+1)14   |
//+----------------------------------------------------------------------------+
//double CalcEquity(int j, int StartShift)
void EquityCalculate()
  {
  double res, sum, k2, l_bl;
  double ProfitBaseVal; //    
  double ProfitUSD;
  int i,j;
  string BaseVal;
  
  //   
  for(j=0; j<LendhtChannelBars; j++)
    {
    //   
    sum=0.;
    for(i=0; i<nSymb; i++)
      {
      if(F_Typ[i]==0)  // buy
        {
        k2=iCloseSymbols[j][F_Symb[i]];
        ProfitBaseVal=F_Lots[i]*BaseLots[F_Symb[i]]*(k2-iCloseSymbols[LendhtChannelBars][F_Symb[i]])/k2;
        }
      else
        {
        l_bl=F_Lots[i]*BaseLots[F_Symb[i]];
        ProfitBaseVal=l_bl*iCloseSymbols[LendhtChannelBars][F_Symb[i]]/iCloseSymbols[j][F_Symb[i]]-l_bl;
        }
      //    USD
      BaseVal=StringSubstr(Symbols[F_Symb[i]],0,3);
      if(BaseVal=="USD") ProfitUSD=ProfitBaseVal;
      if(BaseVal=="EUR") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][0];  // 0 - EURUSD
      if(BaseVal=="GBP") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][1];  // 1 - GBPUSD
      if(BaseVal=="AUD") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][4];  // 4 - AUDUSD
      if(BaseVal=="NZD") ProfitUSD=ProfitBaseVal*iCloseSymbols[j][6];  // 6 - NZDUSD
      if(BaseVal=="CHF") ProfitUSD=ProfitBaseVal/iCloseSymbols[j][2];  // 2 - USDCHF
      if(BaseVal=="CAD") ProfitUSD=ProfitBaseVal/iCloseSymbols[j][5];  // 5 - USDCAD
      
      //  
      sum=sum+ProfitUSD;
      }
    Equity[j]=sum;
    }
  return;
  }

//+----------------------------------------------------------------------------+
//|                                             |
//|       Equity[]  LendhtChannelBars;   |
//|      a,b,bh,bl.                             |
//+----------------------------------------------------------------------------+
void RGRCalculate()
  {
  int i;
  double sumX,sumY,sumXY,sumX2,DeltaMax,Delta,RGR;
  
  //     . 
  sumX=0; sumY=0; sumXY=0; sumX2=0;
  for(i=0;i<LendhtChannelBars;i++)
    {
    sumX+=i;
    sumY+=Equity[i];
    sumXY+=i*Equity[i];
    sumX2+=i*i;
    }	
  a=(LendhtChannelBars*sumXY-sumX*sumY)/(LendhtChannelBars*sumX2-sumX*sumX);
  b=(sumY-a*sumX)/LendhtChannelBars;
  
  //      
  DeltaMax=0.;
  for(i=1; i<LendhtChannelBars; i++)
    {
    RGR=a*i+b;
    Delta=MathMax((Equity[i]-RGR),(RGR-Equity[i]));
    if(Delta>DeltaMax) DeltaMax=Delta;
    }
  bh=b+DeltaMax;
  bl=b-DeltaMax;
  
  return;
  }
//+-------------------------------------------------

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void DelObj()
  {
  ObjectDelete("TL11");
  ObjectDelete("TL21");
  ObjectDelete("MIDL1");
  }

//+----------------------------------------------------------------------------+
//|    ( USD)   .                      |
//|       F_Symb[],F_Lots[]                     |
//|                                                         nSymb;     |
//+----------------------------------------------------------------------------+
double SpreadCalculate()
  {
  double res;
  int i;
  
  res=0.;
  for(i=0; i<nSymb; i++)
    res=res+MarketInfo(Symbols[F_Symb[i]],MODE_SPREAD)*MarketInfo(Symbols[F_Symb[i]],MODE_TICKVALUE)*F_Lots[i];
  return(res);
  }


//+----------------------------------------------------------------------------+
//|    (  .  .)  USD   .    |
//|       F_Symb[],F_Typ[],F_Lots[]             |
//|                                                         nSymb;     |
//+----------------------------------------------------------------------------+
double SwapCalculate()
  {
  double res;
  int i;
  
  res=0.;
  for(i=0; i<nSymb; i++)
    {
    if(F_Typ[i]==0) // buy
      res=res+MarketInfo(Symbols[F_Symb[i]],MODE_SWAPLONG)*MarketInfo(Symbols[F_Symb[i]],MODE_TICKVALUE)*F_Lots[i];
    else
      res=res+MarketInfo(Symbols[F_Symb[i]],MODE_SWAPSHORT)*MarketInfo(Symbols[F_Symb[i]],MODE_TICKVALUE)*F_Lots[i];
    }
  
  return(res);
  }

